///! @file $RCSfile: pfc_ctrl.h,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! Please read file license.txt for copyright notice.
//!
//! @brief This file contains the low level macros and definitions for the 
//! ballast control (DALI & Switch Control
//! @version $Revision: 1.11 $ $Name:  $
//!
//! @todo
//! @bug

#ifndef CONTROL_LIB_H
#define CONTROL_LIB_H

//_____ I N C L U D E S ____________________________________________________

//! @defgroup PFC_module PFC Module
//! PFC Module
//! @{


//_____ M A C R O S ________________________________________________________



//_____ D E F I N I T I O N S ______________________________________________



//! @defgroup Reference_design_control_status_definitions Reference Design Control status Definitions
   //! Reference Design Control Status Definitions
   //! @{

      //! @defgroup Control_status_definitions Control status Definitions
      //! Control Status Definitions
      //! @{
#define WAIT_FOR_FIRST_COMMAND                     0
#define DALI_CONTROL                               1
#define SWITCH_CONTROL                             2
      //! @}

      //! @defgroup Control_definitions Control Definitions
      //! Control Definitions
      //! @{
#define UP         1 //!< To know the dimming should be increased
#define DOWN       0 //!< To know the dimming should be decreased

#define MIN_SHORT_TOUCH_SET 25  //!<  25 * 2 * TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS = 100mS to validate the touch is set
#define MIN_LONG_TOUCH_SET 100  //!< 100 * 2 * TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS = 400mS to consider it is a long touch set
#define MIN_TOUCH_RELEASED  50  //!<  50 * TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS = 100mS to validate the touch is released
#define SWITCH_DELAY        10  //!<  10 * TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS =  20mS for a current step

#define USE_ZERO_TEN_VOLT_CONTROL   1
#define USE_SWISS_CONTROL           2
#define USE_DALI_CONTROL            3

      //! @}

   //! @}

//_____ F U N C T I O N S __________________________________________________

void control_task(void);

//! @}
#endif  // CONTROL_LIB_H
