//! @file $RCSfile: lamp_ctrl.c,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! Use of this program is subject to Atmel's End User License Agreement.
//! Please read file license.txt for copyright notice.
//!
//! @brief This file is a template for writing C software programs.
//!
//! This template file can be parsed by Doxygen for automatic documentation
//! generation.
//! Put here the functional description of this file within the software
//! architecture of your program.
//!
//! @version $Revision: 1.8 $ $Name: megaballast-refd-0_2_9 $ $Id: lamp_ctrl.c,v 1.8 2005/09/05 08:32:30 ebouin Exp $
//!
//! @todo
//! @bug

//_____  I N C L U D E S ___________________________________________________
#include "main_FBKIT.h"

//_____ M A C R O S ________________________________________________________



      
//_____ D E F I N I T I O N S ______________________________________________

//! This variable is timer variable which is incremented thanks to the timer in main_megaballast_ref_d.c
extern volatile U8  gv_pfc_state;
extern volatile U8  gv_lamp_state;
extern volatile U8  gv_control_state;

extern volatile U8 gv_lamp_preset_current;
extern volatile U8 gv_lamp_on;

extern U8  g_control_time_since_previous_timer_reset; 
extern U8  lamp_status;
extern U8  g_too_many_ignition_tries;

volatile U8 gv_init_lamp_preset_current = 0;
volatile U8 gv_output_level             = 0;


U8 g_control_means = 0;

   //! @defgroup Reference_design_switch_control_variables_definitions Reference Design Switch Control Variables Definitions
   //! Reference Design Switch Control Variables Definitions
   //! @{
static   U8    gs_nbr_read_switch_shot_one             = 0;
static   U8    gs_nbr_read_switch_shot_zero            = 0;
static   U8    gs_dimming_direction                    = 0;
static   U8    gs_switch_delay                         = 0;
   //! @}


//_____ D E C L A R A T I O N S ____________________________________________


/*
U8 return_preset_current(U8 dali_level){
  if (dali_level <= 40){
    return (25);
  }
  if (dali_level <= 160){
    return (  25 + ((dali_level- 40)/8) );
  }
  if (dali_level <= 200){
    return (  40 + ((dali_level-160)/4) );
  }
  if (dali_level <= 220){
    return (  50 + ((dali_level-200)/2) );
  }
  if (dali_level <= 240){
    return (  60 + ((dali_level-220)*1) );
  }
  if (dali_level <= 250){
    return (  80 + ((dali_level-160)*2) );
  }
  return (    100 +  (dali_level-250)    );
}
*/
//! This function allows to control the ballast
//!
//! @warning Code:xx bytes (function code length)
//!
//! @param None
//!
//! @return None
//!

void control_task(void){ 

  switch (gv_control_state) {

    case WAIT_FOR_FIRST_COMMAND: {
    
#ifdef _DALI_CONTROL      
      //!< Is DALI used?
      if (is_dali_running() == 1){
        gv_control_state = DALI_CONTROL;
      }
#endif // _DALI_CONTROL
      
#ifdef _SWITCH_CONTROL      
      //!< Is switch Control used? ... Read the input pin
      if (    g_control_time_since_previous_timer_reset
         >= LOW_TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS )
      {
        g_control_time_since_previous_timer_reset = 0;
        if (PINB & (1 << PINB6)){
          if (gs_nbr_read_switch_shot_one < 250){
            gs_nbr_read_switch_shot_one ++;
          }
        }else{
          gs_nbr_read_switch_shot_one = 0;
          if (gs_nbr_read_switch_shot_zero < 250){
            gs_nbr_read_switch_shot_zero ++;
          }
          //!< Software pull-up
          PORTB |=  (1 << PORTB6);
          PORTB &= ~(1 << PORTB6);
        }
        //!< ... Analyse the touch dim command
        if (gs_nbr_read_switch_shot_zero >= MIN_SHORT_TOUCH_SET){
          gv_lamp_preset_current = MAX_TWO_LAMP_PRESET_CURRENT;
          gs_dimming_direction = DOWN;
          gs_nbr_read_switch_shot_zero = 0;
          gv_control_state = SWITCH_CONTROL;
        }
      }  
#endif // _SWITCH_CONTROL     
      
      break;
    } //!< END case WAIT_FOR_FIRST_COMMAND
  
#ifdef _DALI_CONTROL      
    case DALI_CONTROL: {
      gv_output_level = dali_control_gear(lamp_status);
      if (gv_output_level == 0){
        gv_lamp_preset_current = 0;
      }else{
        if (gv_output_level <= MIN_TWO_LAMP_PRESET_CURRENT){
          gv_lamp_preset_current = MIN_TWO_LAMP_PRESET_CURRENT;
        }else{
          if (gv_output_level >= MAX_TWO_LAMP_PRESET_CURRENT){
            gv_lamp_preset_current = MAX_TWO_LAMP_PRESET_CURRENT;
          }else{
             gv_lamp_preset_current = gv_output_level;
          }
        }
      }
      break;
    } //!< USE_DALI_CONTROL
#endif // _DALI_CONTROL
  
#ifdef _SWITCH_CONTROL      

    case SWITCH_CONTROL: {
      if (    (    (gv_lamp_on == 0)
                && (g_control_time_since_previous_timer_reset
                    >= LOW_TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS ) )
           || (g_control_time_since_previous_timer_reset
               >= TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS )    )
      {
#ifdef _DEBUG_SWITCH_CONTROL
        PORTD |= (1 << PIND4);
#endif //!< _DEBUG_SWITCH_CONTROL
        
        g_control_time_since_previous_timer_reset = 0;
        //<! Read the input pin
        if (PINB & (1 << PINB6)){
          if (gs_nbr_read_switch_shot_one < 250){
            gs_nbr_read_switch_shot_one ++;
          }
        }else{
          gs_nbr_read_switch_shot_one = 0;
          if (gs_nbr_read_switch_shot_zero < 250){
            gs_nbr_read_switch_shot_zero ++;
          }
          //!< Software pull-up
          PORTB |=  (1 << PORTB6);
          PORTB &= ~(1 << PORTB6);
        }
        //!< Analyse the touch dim command
        if (gs_nbr_read_switch_shot_one >= MIN_TOUCH_RELEASED){
          //<! Assume that it's a 1 (touch dim is released)
          if (    (gs_nbr_read_switch_shot_zero >= MIN_SHORT_TOUCH_SET)
               && (gs_nbr_read_switch_shot_zero <= MIN_LONG_TOUCH_SET) )
          {
            //<! The touch dim has just been released from a short pulse (<300ms)
            if (gv_lamp_preset_current == 0) {
              //!< Lamp is Off so: Switch on the light
              if (gv_init_lamp_preset_current == MAX_TWO_LAMP_PRESET_CURRENT){
                gs_dimming_direction = DOWN;
              }else{
                gs_dimming_direction = UP;
              }
              gv_lamp_preset_current = gv_init_lamp_preset_current; 
            }else{
              //!< Lamp is running so: Switch off the light
              gv_init_lamp_preset_current = gv_lamp_preset_current; 
              gv_lamp_preset_current = 0;
            }
          }else{
            if (gs_nbr_read_switch_shot_zero > MIN_LONG_TOUCH_SET){
              //<! The touch dim has just been released from a long pulse (<300ms)
              //<! It is necessary to reverse the dimming direction
              if (gs_dimming_direction == UP){
                gs_dimming_direction = DOWN;
              }else{
                gs_dimming_direction = UP;
              }
            }
          }//!< End Touch dim is released
          //<! Anyway now the g_s_nbr_read_switch_shot_zero can be reset
          gs_nbr_read_switch_shot_zero = 0;
        }//!< End it was a 1
        if (gs_nbr_read_switch_shot_zero >= MIN_SHORT_TOUCH_SET){
          //<! Assume that it's a 0 (touch dim smashed-in)
          //!< This is the case the user is using the "touch dim"
          if (gs_nbr_read_switch_shot_zero > MIN_LONG_TOUCH_SET){
            //!< The dimming touch is applyed for a long time (higer than 300ms)
            gs_switch_delay ++;
            if (gv_lamp_preset_current == 0) {
              //!< Lamp is Off so: Switch on the light
              if (gv_init_lamp_preset_current == MAX_TWO_LAMP_PRESET_CURRENT){
                gs_dimming_direction = DOWN;
              }else{
                gs_dimming_direction = UP;
              }
              gv_lamp_preset_current = gv_init_lamp_preset_current; 
            }else{
              if (gs_switch_delay > SWITCH_DELAY){
                gs_switch_delay = 0;
                if (gs_dimming_direction == DOWN){
                  if (gv_lamp_preset_current > MIN_TWO_LAMP_PRESET_CURRENT){
                   gv_lamp_preset_current --;
                  }
                }else{
                  gv_lamp_preset_current ++;
                }
              }
            }
            //!< Update the preset current
            if (gv_lamp_preset_current > MAX_TWO_LAMP_PRESET_CURRENT){
              gv_lamp_preset_current = MAX_TWO_LAMP_PRESET_CURRENT;
            }else{
              if(gv_lamp_preset_current < MIN_TWO_LAMP_PRESET_CURRENT){
                gv_lamp_preset_current = MIN_TWO_LAMP_PRESET_CURRENT;
              }
            }//!< END Update the preset current
          }//!< END The dimming touch is applyed for a long time (higer than 300ms)
        } //!< END it was a 0

#ifdef _DEBUG_SWITCH_CONTROL
        PORTD &= ~(1 << PIND4);
#endif //!< _DEBUG_SWITCH_CONTROL
      
      } //!< END if ... >= TIME_TO_WAIT_BETWEEN_TWO_CONTROL_TASKS
      break;
    } //!< END case SWITCH_CONTROL
#endif // _SWITCH_CONTROL

  } //!< END switch
  
  if (   (    (gv_lamp_preset_current == 0)
           && (gv_lamp_on == 1            ) ) 
      || (g_too_many_ignition_tries == 1    )  ){
    //!< Switch off the lamp
    Disable_both_psc2_outputs();
    Stop_psc2();
    Disable_amp0();
    Disable_both_psc0_outputs();
    Stop_psc0();
    gv_lamp_on = 0;
    gv_lamp_state = LAMP_OFF;
    if (gv_pfc_state != PFC_PROBLEM){
      gv_pfc_state = SHUT_DOWN_PFC_AND_SLOW_DOWN_UC_SPEED;
    }
  }
  
  if (    ( gv_lamp_preset_current != 0       )
       && ( gv_lamp_on == 0                   ) 
       && ( g_too_many_ignition_tries == 0    ) ){
    gv_lamp_on = 1;
  }
}    
