//! @file $RCSfile: main_pwmx_fluo_demo.c,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! Use of this program is subject to Atmel's End User License Agreement.
//! Please read file license.txt for copyright notice.
//!
//! @brief This file is a template for writing C software programs.
//!
//! This template file can be parsed by Doxygen for automatic documentation
//! generation.
//! Put here the functional description of this file within the software
//! architecture of your program.
//!
//! @version $Revision: 1.13 $ $Name: megaballast-refd-0_2_9 $ $Id: main_pwmx_fluo_demo.c,v 1.13 2006/01/05 13:42:07 ebouin Exp $
//!
//! @todo
//! @bug

//_____  I N C L U D E S ___________________________________________________
#include "main_FBKIT.h"

//_____ M A C R O S ________________________________________________________


//_____ D E F I N I T I O N S ______________________________________________

//! @defgroup Reference_design_variables_definitions Reference Design Global Varaibles Definitions
//! Reference Design Global Variable Definitions
//! @{

  //! @defgroup Reference_design_scheduler_state_variables_definitions Reference Design Scheduler State Variables Definitions
  //! Reference Design Scheduler State Variables Definitions
  //! @{
volatile U8  gv_control_state                = 0;
volatile U8  gv_pfc_state                    = 0;
volatile U8  gv_lamp_state                   = 0;
  //! @}

volatile U8    gv_lamp_on                    = 0;
volatile U8    gv_lamp_preset_current        = 0;

U8 lamp_status = 1;
U8 speed_mode =  0; // SLOW;



  //! @defgroup Reference_design_timer_variables_definitions Reference Design Timer Variables Definitions
  //! Reference Design Timer Variables Definitions
  //! @{
U8  g_pfc_time_since_previous_timer_reset         = 0; 
U8  g_lamp_time_since_previous_timer_reset        = 0; 
U8  g_control_time_since_previous_timer_reset     = 0; 
U8  g_time_since_previous_haversine_check         = 0; 
U8  g_task_to_do                                  = 0;
  //! @}

//! @}

//_____ D E C L A R A T I O N S ____________________________________________

//! This function allows to schedule task between PFC and lamp managment
//!
//! @warning Code:xx bytes (function code length)
//!
//! @param None
//!
//! @return None
//!
#pragma vector = TIMER1_CAPT_vect
__interrupt void TIMER1_CAPT_interrupt(void);

__interrupt void TIMER1_CAPT_interrupt(void){
#ifdef _DEBUG_SCHEDULER
  PORTD |= (1 << PIND3);
#endif //!< _DEBUG_SCHEDULER
  g_pfc_time_since_previous_timer_reset ++; 
  g_lamp_time_since_previous_timer_reset ++;
  g_control_time_since_previous_timer_reset ++; 
  g_time_since_previous_haversine_check ++; 
  if (g_task_to_do == 0){
    pfc_task();
    g_task_to_do = 1;
  }else{
    lamp_task();
    g_task_to_do = 0;
  }
#ifdef _DEBUG_SCHEDULER
  PORTD &= ~(1 << PIND3);
#endif //!< _DEBUG_SCHEDULER

#ifdef _DALI_CONTROL  
  dali_tick();
#endif //!< _DALI_CONTROL

}

//! This function allows to initialize all the micrcontroller ports for the
//! application
//!
//! @warning Code:xx bytes (function code length)
//!
//! @param None
//!
//! @return None
//!
void init_ports(void){

   // ****** Init Ports
   // DDRx  = 1 outpout,     DDRx  = 0 input
   // PORTx = 1 output high, PORTx = 0 output low
   // PINx is the read value at the input of the microcontroller
   // Setting PINx if the port is configured as an output make it toggled

   //! PB7 : ADC4       PIN24 V_HAVERSINE   001 Haversine Voltage Measurement
   //! PB6 : ADC7       PIN23 SWITCH_CTRL   000 Switch control input
   //! PB5 : ADC6       PIN22 TEMPERATURE   001 Temperature sensor measurement
   //! PB4 : AMP0+      PIN21 I_LAMP        001 Lamp Current Measurement
   //! PB3 : AMP0-      PIN20 GND           001 Connected to the ground near the Lamp Current shunt
   //! PB2 : ADC5       PIN16 V_BUS         001 Bus Voltage Measurement
   //! PB1 : PSCOUT21   PIN09 INVERTER_H    1O Half Bridge High transistor command
   //! PB0 : PSCOUT20   PIN08 INVERTER_L    10 Half Bridge Low transistor command

#ifdef _FB_KIT     
   //! PD7 : ACMP0      PIN15 PFC_ZCD       001 Zero Crossing Detection
   //! PD6 : ADC3       PIN14 V_LAMP        001 Lamp voltage Measurement
   //! PD5 : ACMP2      PIN13 LAMP_EOL      001 Lamp End of Life detection
   //! PD4 : DALIRX     PIN12 SCK_A         10  OCD pin // Debugg pin
   //! PD3 : DALITX     PIN05 MOSI_A        10  OCD pin // Debugg pin
   //! PD2 : MISO_A     PIN04 MISO_A        00  OCD pin // Debugg pin
   //! PD1 : PD1        PIN03 SINGLE_LAMP   00  Single Lamp Detection
   //! PD0 : PSCOUT00   PIN01 PFC_OUTPUT    10  PFC Output
#endif //!< _FB_KIT
  
#ifdef _LI100  
   //! PD7 : ACMP0      PIN15 PFC_PROTECT   001 PFC over currrent detection
   //! PD6 : ADC3       PIN14 V_LAMP        001 Lamp voltage Measurement
   //! PD5 : ACMP2      PIN13 LAMP_EOL      001 Lamp End of Life detection
   //! PD4 : DALIRX     PIN12 SCK_A         10  OCD pin // Debugg pin
   //! PD3 : DALITX     PIN05 MOSI_A        10  OCD pin // Debugg pin
   //! PD2 : MISO_A     PIN04 MISO_A        00  OCD pin // Debugg pin
   //! PD1 : PD1        PIN03 PFC_ZCD       00  PFC Zero crossing detetction
   //! PD0 : PSCOUT00   PIN01 PFC_OUTPUT    10  PFC Output
#endif //!< _LI100
  
   //! PE0 : RESET      PIN02  RESET        00 OCD Pin
   //! PE1 : XTAL1      PIN10  XTAL1        00 XTAL1
   //! PE2 : XTAL2      PIN11  XTAL2        00 XTAL2

   DIDR0 = 0x7C; //!< Disable Pull-up of ADC6, 5, 4, 3 and ACMP2
   DIDR1 = 0X38; //!< Disable Pull-up of ACMP0, AMP0+ and AMP0-

   DDRB  = 0x03; PORTB = 0x00; //!< PORT B configured as specified above ... 
                               //!< Make sure the both inverter inputs are low

#ifdef _DALI_CONTROL
   DDRD = 0x11; PORTD = 0x00;
#else
   DDRD  = 0x19; PORTD = 0x00; //!< PORT D configured as specified above ...
                               //!< Make sure the input of the PFC is low
#endif //!< _DALI_CONTROL   
   
   DDRE  = 0xF0; PORTE = 0xF0; //!< PORT E configured as specified above
}

//! This function allows to initialize the timer 1 which will
//! be used to generate application base time. (100uS Tick)
//!
//! @warning Code:xx bytes (function code length)
//!
//! @param None
//!
//! @return None
//!
void init_timer(void){
  TCCR1A = 0x00;
  TCCR1B = ( (0x18) | (TIMER_1_PRESCALER_LOW_SPEED) );
  ICR1   = TIMER_1_TOP_LOW_SPEED;
  TIMSK1 = 0x20;
}

//! This function allows to initialize the ADC which will
//! be used to make analog measurments.
//!
//! @warning Code:xx bytes (function code length)
//!
//! @param None
//!
//! @return None
//!
void init_adc(void){
  Enable_adc();
  Left_adjust_adc_result();
  Enable_adc_high_speed_mode();
  Enable_internal_vref();
  Disable_adc_it();
  Set_adc_prescaler(1); // ADCLK is IO clock divided by 2
}

//! The main program do the initialisation off all peripherals,
//! starts the ADC macro, and schedule the Control, PFC and Lamp macros
//! @warning Code:xx bytes (function code length)
//!
//! @param None
//!
//! @return None
//!
int main(void){

  //!< Init ports... being sure all are in a known state
  init_ports();

  // Switch the micro to a low power consuption mode
  Disable_all_it();
  CLKPR = 0x80;
  CLKPR = 0x03;
  Enable_all_it();

  //!< Init all states
  gv_control_state   = WAIT_FOR_FIRST_COMMAND;
  gv_lamp_state      = LAMP_OFF;
  gv_pfc_state       = PFC_OFF;

  //!< Init peripherals usefull for control
  init_timer();

  init_adc();

  lamp_status = 1;
  speed_mode =  0; // SLOW;

#ifdef _DALI_CONTROL  
  dali_init();
  dali_set_speed(speed_mode);
#endif //!< _DALI_CONTROL
  
  gv_lamp_preset_current = 0; //MAX_TWO_LAMP_PRESET_CURRENT; //0;
  
  while(1){
  
    control_task();
    
  }
} //!< END main()
